Overview

Phantom Sidekick Overview

Note - The Phantom Help file should be reviewed prior to using Phantom Sidekick. It provides valuable insight into how Phantom scripts work.

Phantom Sidekick is a macro utility that automates Windows applications by utilizing Phantom scripts. It can be used to automate almost any task, including checking e-mail, siging on to the internet, backing up files, or any other task that is performed using the Windows interface. Phantom scripts can be created manually using the Script Editor, or by using the built-in Recorder, which will follow your actions and create a script for you.

Any windows application can also be launched using Phantom Sidekick, such as opening Internet Explorer with a favorite website automatically, or opening a document editor with a commonly used document. Combining this feature with Triggers and the Macro Quick Menu, Sidekick makes Windows more user friendly and accessible than ever.

Phantom scripts are executed by the Phantom Interpreter. This can occur when certain user-defined key combination are detected, or by running the macro manually using the menu or tool bar. Since Phantom scripts are used, virtually limitless actions can be performed. The Sidekick dialog waits silently for a key combination (also called a 'Key Set', or Trigger) to occur, and then initiates the script execution.

Macro Sets can be created using the Macro Manager. Sets are provided for macro organization. The Macro Manager is used to manage all aspects of a macro, including associating a script with a Trigger, setting the executable, or scheduling a macro. It can be used to create a new macro or change the properties of existing macros.

Phantom Sidekick also has a Macro Scheduler. The Macro Scheduler is used to set a run time for a macro. The schedule can be a one-time run or a repeating run. When the scheduled time arrives, the macro executes automatically. This can be useful for backing up files automatically, downloading internet files automatically, or performing any task that occurs on a regular basis.

When a Phantom macro is executed, the script is run like any other Phantom script. The output of the script is displayed in an output window. Executed macros are also logged in the Sidekick Log.

For more information on what Sidekick does and how it does it, see the following links:

User Interface

Macro Properties

Macro Sets

Macro Quick Menu

Macro Manager

Macro Scheduler

For more information on Phantom scripts and the Phantom Interpreter, read the Phantom help file accompanying Sidekick.


Creating a Macro

Creating a New Macro

To create a new macro, select the ‘New Macro’ menu item from the ‘File’ menu. The ‘Clear Fields’ button can also be clicked in the Macro Manager. When either of these options is selected, the Macro Manager saves the current macro being edited and clears all fields for a new macro. Enter the macro attributes and click the ‘Add Macro’ button to insert the new macro into the macro set. The macro will be inserted into the currently selected macro set or after the currently selected macro in the Macro Viewer.

To add a new set, simply check the ‘Macro Set’ box in the Macro Manager.

A new macro can also be created using the Macro Wizard.


Executing a Macro

There are several methods of executing a macro. A macro can be executed from the main Sidekick window by selecting the Execute menu item from the Macro menu. It can also be executed from the Macro Viewer in the main Sidekick window by right-clicking the macro and selecting the Execute menu item from the pop-up.

The Macro View in the Macro Quick Menu is also a quick way to execute a macro. The Macro Quick Menu is a pop-up window that appears when the icon in the system tray is right-clicked with the mouse. See the Macro Quick Menu for more information.

Macros can be executed outside the main Sidekick application via a Trigger or through macro scheduling. See Macro Triggers and the Macro Scheduler for more information.

When a macro is executed, Sidekick passes the Macro File to the Macro Executable. If Phantom is used as the executable, the file is passed to the Phantom interpreter as a Phantom script. If not, the Macro File is processed by the selected Macro Executable. The macro execution is recorded in the Sidekick Log along with the time of execution. If the Macro is a Phantom script, the output of the script is also displayed in the Macro Output tab.

Only one macro can be run at a time. If a scheduled macro is detected or a Trigger is detected while a macro is running, the new macro will run after the current macro finishes. Up to five macros can be queued to execute. Any macro scheduled when the queue is filled will produce an error in the log.

A Phantom macro can be halted during execution by selecting the Stop menu item from the Macro menu in the main Sidekick window. A macro can also be stopped by right-clicking the tray icon [image] and selecting the 'Stop Executing Macro' menu, or by clicking the Stop Macro [image] button in the main tool bar. If a macro is stopped, the macro queue is cleared.


Macro Scheduler

The Scheduler

The Scheduler tab is used to managing the scheduling of Sidekick macros. All macros currently scheduled, either as a repeated macro or a single occurrence, can be displayed using the Scheduler. Three sections comprise the Scheduler: the Calendar, the Schedule List, and the Schedule Manager. See Macro Schedule for more information on schedule attributes.

The Calendar

The calendar shows a month worth of days. Clicking on one of the days will display that days macro schedule in the Schedule List. All days with a non-repeating macro or macro with a repeating schedule greater than one month will appear bold in the calendar. Different months can be selected by clicking the left and right arrows at the top of the calendar. The current day can be selected by clicking the ‘Today’ circle.

The Schedule List

The Schedule List displays all scheduled macros for the currently selected day. The macros are organized starting with repeating macros followed by single occurrence macros scheduled at increasing times of the day. Double-clicking an item displays the macro scheduling information in the Schedule Manager.

Macros can be scheduled automatically by dragging the icon in the Macro Viewer into the Schedule List. The macro will be inserted after the selected time slot, and its scheduling information will be updated.

Schedule Manager

The Schedule Manager displays the scheduling information for the selected macro in the Schedule List. Scheduling information can be changed using the Schedule Manager. Any changes must be confirmed by clicking the ‘Update’ button. With many macros with similar or the same names, it may be difficult to determine which macro is scheduled. The ‘Find’ button will highlight the macro in the Macro Viewer. To manage other attributes of the macro in the Schedule Manager, click the ‘Manage’ button to view the macro in the Macro Manager.


Macro Sets

A macro set is used to organize macros. Macro sets cannot be executed or scheduled, and are only used for organizational purposes. To create a macro set, create a new macro and check the ‘Macro Set’ box. Macro sets can be cut, copied, and pasted like any macro. A macro set is indicated by the [image] icon.


Macro Triggers

Macro Triggers are a set of keys that, when pressed, execute the macro. Phantom Sidekick does not need to be the active application for Triggers to work - Sidekick will catch the Triggers no matter what application is active. There are two components to a Trigger: the Prefix Key and the Key Combination. Both can be set using the Macro Manager. More than one macro can have the same Trigger. If this is the case, the first macro encountered by Sidekick is executed. Since this can be unpredictable, each macro should have a unique Trigger.

Prefix Keys

Prefix Keys are special keys that are pressed to notify Sidekick that a key combination is about to be pressed. It is similar to activating a macro before running it. This allows for more key combinations that don’t interfere with other applications.

There are two prefix keys that can be used - the CTRL key and the SHIFT key. These keys were chosen because with most applications the CTRL and SHIFT key have no associated actions when pressed by themselves. Each prefix activates associated macros for five seconds. If another macro is executed during that time, the prefix expires.

Key Combinations

Key Combinations are sets of keys that, when pressed simultaneously, execute a macro. Any set of keys can be used as a Key Combination, and the Key Combination can have one or more different keys. A key cannot be used more than once in a Key Combination. Key Combinations are set for a macro using the Macro Manager. Simply place the cursor in the Key Combination field and type the keys that will activate the macro. The keys typed will appear in brackets (<>). For example, a Key Combination of ‘ALT’ and ‘H’ will appear as <ALT><H> in the Key Combination box. To reset this field, simply click the ‘Clear’ button.

The key combination must be pressed simultaneously in order to execute the macro. Also, if the macro has a Prefix Key associated with it, that key must have been pressed to activate the macro.

An example of using Prefix Keys and Key Combinations follows:

A macro has CTRL as a prefix key, with the keys F1 and G as the Trigger Key Combination. In order to activate the macro, the CTRL key is pressed, and then released. This activates the macro five seconds. If the F1 and G key are pressed simultaneously during this time, the macro is executed. If F1 and G are not simultaneously during this time, and no other macro with a CTRL prefix is triggered, the prefix expires.


Macro Quick Menu

The Macro Quick Menu provides a quick and easy way to execute macros while the main Sidekick window is hidden. The Quick Menu can be activated by right-clicking on the [image] icon in the system tray. A Macro Viewer will appear with a list of all available Sidekick macros. A macro can be executed from this menu by selecting a macro. The Quick Menu will automatically disappear and the macro will begin executing. The Quick Menu can be closed without executing a macro by clicking the ‘Cancel’ button.

If another macro is executing (the [image] icon is displayed), a menu will appear prompting you to stop executing the current macro. Select the menu to stop the macro. Any currently running macros must be stopped before a new macro can be executed.


Macro Wizard

The Macro Wizard is used to create common macros easily. To use the Macro Wizard, select the ‘Macro Wizard’ menu item from the ‘File’ menu or click the ‘Wizard’ button in the main tool bar. The Macro Wizard dialog will appear. Follow the instructions and click the ‘Next’ button until the ‘Finish’ button appears. Verify the information in the last dialog, and click ‘Finish’ to add the newly created macro. The new macro will be inserted in the selected macro set or after the currently selected macro in the Macro Viewer.

The first step of the Macro Wizard requests a macro name and what type of macro to create. The rest of the steps depend on what kind of macro will be created.

The different types of macros created by the Macro Wizard are as follows:

Recording a Script - Opens the Script Recorder to begin recording new actions.

Open Application - Opens an application and optionally passes a file to the application.

Copy Files / Folders - Copies a set of files or folders to a new folder.

Alert Message - Displays a Phantom Alert message with custom text.

TypeKeys Sequence - Types a set of keys in the current application. Will either type straight text or special keys, such as ‘ALT’ and ‘F1’. See the TypeKeys documentation in the Phantom language help file.


Phantom Scripts

Phantom scripts are used to perform the majority of Sidekick macros. A Phantom script is a set of instructions indicating what actions to perform. The actions can range from automating windows to backing up files.

Phantom scripts are written using the Phantom language. They are executed using the Phantom Interpreter. A log file is created for a Phantom script with the same name as the script, with a .log extension. For example, the script 'test.psc' creates a log file 'test.log' in the same directory when the script is executed.

See the included Phantom help file for more information on Phantom scripts.


Recording a Script

Phantom Sidekick can record actions by using the Recorder. Mouse clicks and keyboard actions can be recorded as a Phantom script and played back as a macro. These actions can then be 'played back' by running the script created by the recorder.

To record a script, click the 'Record->Script' menu item from the 'Script' menu. The 'Record Script' dialog will appear. Recording starts when the 'Start' button is pressed. All actions performed using the mouse or keyboard will be recorded until the 'Stop' or 'Cancel' button is pressed. Actions recorded will be displayed in the dialog box. These are the same commands that will be used by Phantom when the script is played back. No actions performed on Sidekick will be recorded during a recording.

Recording can also be stopped using the stop key set defined in the Record dialog. Recording will stop when the two keys are pressed at the same time. The stop key set is one of 'Alt', 'Shift', or 'CTRL', and any alpha-numeric character. This is useful to stop recording when Sidekick is hidden, so the action of making Sidekick visible is not recorded. The stop key set will appear when the mouse hovers over the record ( [image]) icon in the system tray as a reminder.

Sidekick can be hidden while recording so it is out of the way. To do this, check the 'Hide while recording' box. When recording starts, Sidekick will hide. When recording is stopped, Sidekick will reappear.

To truncate window classes that begin with 'Afx:', select the 'Truncate Afx:' checkbox. This replaces the class name with 'Afx:*'. This is due to the fact that classes that begin with 'Afx:' often have dynamic class names, and won't be recognized when the script is played back. For more information, consult the Window Declarations Recorder section in the Phantom documentation.

When recording is finished, the 'Stop' button must be pressed. The script can then be edited and saved as a Phantom script. The 'Cancel' button can also be pressed, aborting the recording process. A script is saved by pressing the 'Save' button in the 'Record Script' dialog. Once a script is saved, it can be run using any application that runs Phantom scripts, including the DOS based Phantom and the Phantom Test Driver.

Recording does not capture all actions. Only mouse click events and keyboard events will be recorded. Other commands that interact with a window can be inserted once recording is completed.

Script play-back speed can be changed using the 'SetDelay' Phantom command. This is automatically entered using the Default Delay value from the Settings. This number is the number of milliseconds that Phantom will wait before proceeding to the next command. See the Phantom Help file for more information.

Window commands that were recorded are different than window commands using window declarations. A window command that is recorded is a generic window that includes the type of window, the window tag, and the window class. All properties of a regular window declaration can be used on a recorded window, including wildcard characters (*), and recorded windows are treated the same as window declarations by the Phantom interpreter. The syntax of a recorded window is:

WindowType(WindowTag, WindowClass).WindowType(WindowTag, WindowClass)....Action;

Where,

WindowType- Is the type of window (MainWin usually)

WindowTag- Is the text or numerical tag of the window

WindowClass- Is the class name of the window (ex: Button)

Action- Is the action to perform on the window

Example:

MainWin("Notepad*", "Notepad").MainWin(1,"Edit").TypeKeys("Hello");

See the Phantom documentation for more information on Window Declarations and recorded actions.


Script Editor

Sidekick Editor

The Sidekick Editor is primarily designed to create and edit Phantom scripts. However, it can also be used to edit other ASCII text files. The editor consists of two parts: the File Viewer and the Window Declarations Viewer.

The File Viewer

The File Viewer is used to view the text of a file. For non-Phantom files, this is the only part of the editor used. The File Viewer can be used to alter the text of a file, primarily to alter or create a Phantom script.

Text can be cut, copied, and pasted using the ‘Cut’, ‘Copy’, and ‘Paste’ menu items under the ‘Edit’ menu. Operations can also be un-done and re-done using the ‘Undo’ and ‘Redo’ menu items under the ‘Edit’ menu.

Actions can be undone using the 'Undo' menu item. Similarly, actions that have been undone can be redone using the 'Redo' menu item. Both of these menu items are located in the 'Edit' menu.

Search and replace can be performed using the 'Find' and 'Replace' menu items in the 'Edit' menu. This can be used to find a phrase in the current script or replace one phrase with another.

The text portion of the editor can be printed to a file or printer using the ‘Print’ command under the ‘File’ menu.

The Window Declarations Viewer

The Window Declarations Viewer displays all window declarations file used by the currently open script. Any declarations file included in the script by using the ‘use’ command. An error is produced in the view if the declarations file is not of the correct format or the file is not found. The Window Declarations Viewer is only used by Phantom scripts.

The Window Declarations contained in the file is displayed as a tree of items representing the window elements of a window. They are displayed in hierarchal order. In other words, top level windows are at the highest level of the tree, and child items are displayed as sub-items of the top level window. Each successive level of child items is a sub-level in the window tree.

The properties of each window declaration item can be viewed by double-clicking the item. A dialog will appear displaying the properties of the window. These can be changed using the dialog. See the Window Declarations section of the Phantom language documentation for more information on editing declarations.

The following defines the different icons used in the Window Declarations Viewer:

- A Window Declarations file used by the script.

- A window or control.

- A menu or menu item.

Window Declarations can be dragged directly into a Phantom script. When the item is dragged into the File Viewer, the text representing the window declaration will appear. See the Window Declarations section of the Phantom language documentation for more information on using declarations.

The Window Declarations Viewer is updated automatically while editing a script. It can also be updated manually by selecting the 'Refresh Decs' menu item from the 'File' menu.

Saving a File in the File Viewer

Both the file and window declarations can be saved by selecting the ‘Save All’ menu item from the ‘File’ menu or the ‘Save->All’ menu item in the ‘File’ menu. To only save the text file, select the ‘Save->Script’ menu item under the ‘File’ menu. To only save the declarations, select the ‘Save->Declarations’ menu item from the ‘File’ menu. If changes are made to the text file, a prompt will appear to save changes prior to exiting the editor.

Help

Help with the Phantom language or Phantom Sidekick can be found by selecting the ‘Help’ menu.


Script Arguments

Arguments to Phantom scripts can be added by placing "ARGS=" after the script name in the Macro Manager. Regular Phantom commands can then be added after the "ARGS=". The commands will be interpreted as Phantom arguments.

Example:
myscript.psc ARGS=int i = 10; string s = "Hello";

For more information on Phantom arguments, consult the Phantom help file.


Settings

Phantom Sidekick can be modified by setting options in the Options dialog. The settings dialog can be accessed by selecting the ‘Options’ menu item from the ‘Settings’ menu. Using the Options dialog, the following settings can be modified:

·Triggers can be enabled at the start of the application (default)

·The Scheduler can be enabled at the start of the application (default)

·The application can be hidden to the System Tray at start up

·The default delay time for recording can be set

·The number of lines after which the Log file is automatically cleared (Auto-cleared).

The registration key is also displayed in the Options dialog. Setting the Auto-clear value to zero prevents the Log file from being cleared.

The Settings menu can also be used to disable macro Triggers and the Macro Scheduler. If Triggers are disabled, macros can no longer be activated by pressing their assigned key combination. If the Macro Scheduler is disabled, scheduled macros will not be executed automatically at the assigned time.


Registering Sidekick

Registering Phantom Sidekick prevents the 30-day expiration of the trial version. Sidekick can be registered by visiting the following site:

http://www.phantomtest.com


Restoring a Macro Set

The macro set in the Macro Viewer can be restored to the last save state by selecting the 'Restore Macros' menu item from the 'File' menu. Restoring a set loads the backup macro file (Macros.bak). The backup macro file contains the last saved state of the macro set. The Macros.back file is overwritten with a new state whenever the macros are saved.

Restoring is useful if an unintended change is made or a macro is deleted on accident. The restore must be performed before Sidekick is exited or saved.

Restoring does not affect any of the Phantom scripts that are associated with the macros.


Phantom Interpreter

The Phantom interpreter is the engine (phantom.dll) that parses and processes the commands in a Phantom script. The interpreter tracks all windows used by the script, as well as the window declarations, variables, and output. Scripts are sent to the interpreter via Phantom Sidekick or the included DOS based Phantom.exe.

The interpreter finds the window to process based upon the command structure. It then passes information to that window dependant upon the function being called.

The following example illustrates how to use the interface 'phantom.exe'. The command is typed in directly in the DOS prompt.

Example:

phantom.exe test.psc

Where 'phantom.exe' is the DOS interface, 'test.psc' is the script, and 'test.log' is the output file created by the script. Any messages from the script are printed directly to the DOS screen when using Phantom.exe.

To execute a script from Phantom Sidekick, see Executing a Macro.

For more information on the Phantom Interpreter and Phantom scripts, see the Phantom documentation (the included Phantom help file).


Macro Manager

Sidekick macro attributes are edited using the Macro Manager. The Macro Manager is the first tab of the main Sidekick window. The Manager will contain the macro attributes of the currently selected macro, indicated by a [image]. The Macro Name, File, Executable, and Description can be altered simply by changing the appropriate fields.

To manage a macro, simply double click on the macro or macro set in the Macro Viewer. The macro attributes will appear in the manager. Pressing the 'space' bar in the Macro Viewer will also show the highlighted macro's attributes. The currently selected macro is indicated by a [image].

Checking the ‘Macro Set’ box declares the current macro as a macro set. Checking the ‘Use Phantom’ box declares the macro as a Phantom script. In this case, the ‘Macro File’ will be passed to the Phantom Interpreter. See the Phantom language documentation for more information.

The Macro Trigger and Macro Schedule are also set using the Macro Manager. The last time the macro was executed is displayed in the ‘Last Run’ field.

To update the macro attributes, simply select another macro or Save the macro set.

A new macro can be added to the Macro Viewer by filling in all the macro attributes and clicking the 'Add Macro' button. The new macro will appear in the macro set currently selected in the Macro Viewer. A new macro can also be added via the Macro Wizard by clicking the 'Wizard' button in the main tool bar or by selecting the 'File->Macro Wizard' menu item. Be sure to select the macro set that will contain the new macro before adding it. The default is the root macro.


Macro Properties

A macro has several properties that can be set using the Macro Manager. These properties are used to define what the macro does as well as user interaction with the macro. The properties of a macro include the following:

·Name

·File

·Executable

·Description

·Trigger

·Run Schedule

Macro Name

The macro name is used to identify the macro to the user. The name is displayed whenever a macro is executed and is displayed in the Macro Viewer and Macro Quick Menu. Multiple macros can have the same name in Phantom Sidekick. There are no restrictions to what a macro can be called, and all macros must have at least a name.

The macro name is set using the Name field in the Macro Manager.

Macro File

The macro file is the file passed to the Macro Executable. Usually this is a Phantom Script passed to the Phantom Interpreter. However, it can also be a file passed to another application: a text file passed to the notepad application for example. The file is passed similarly to a file passed to an application through the command line. For example:

notepad.exe test.txt

Where notepad.exe is the executable (in the Macro Executable field of the Macro Manager) and test.txt is the file opened by notepad, in the Macro File field Macro Manager.

Macro Executable

The Macro Executable is the application the Macro File is passed to when the macro is executed. For most macros this is the Phantom interpreter, so this field is not normally used. If the default ‘Use Phantom’ box is checked then this field is disabled. If Phantom is not used as the executable, then this field specifies which executable to launch.

Macro Description

The Macro Description field can be used to enter a short description of what the macro performs.

Macro Trigger

The Macro Trigger defines the key combination that launches the macro. The Trigger can be any combination of keys with an optional prefix key. If all keys in the Trigger are pressed simultaneously, the macro is executed. The Prefix is a key that is pressed then released, followed by a normal key combination. See the Triggers section for more information.

Macro Schedule

The Macro Schedule defines when a macro will run automatically. There are three types of schedules for a macro. They are:

· Not Scheduled

· Single Occurrence

· Repeated

Each scheduled macro also has a run time and a run frequency, which can also be set using the Macro Manager. The last run time is displayed in the 'Last Run' box. See Macro Scheduler for more details.


Contents

Overview

Macro Triggers

Macro Properties

Scheduling Macros


Main Sidekick Window

The Main Sidekick Window is the main interface for Sidekick. It is the window that appears when Sidekick is executed before it is hidden. The main window contains the Macro Viewer on the left side and a set of tabs on the right side. The tabs contain the Macro Manager, Macro Scheduler, Macro Output, and Macro Log. Selecting a tab will display the corresponding window.

The main window can be hidden from view by using the ‘Hide’ command from the ‘File’ menu. The window can also be hidden by double-clicking the Sidekick icon in the System Tray or by clicking the [image] button in the main tool bar. To un-hide the window, double-click the Sidekick icon in the System Tray. The main window can also be hidden automatically using the Settings dialog.

Menu items along the top of the window can also be used to control Sidekick.

The main sidekick window is displayed below:


Saving a Macro Set

Saving the Macro Set

To save a macro set, select the ‘Save Macros’ menu item from the ‘File’ menu, or by clicking [image] in the main tool bar. The macro set will also save automatically when Phantom Sidekick closes.

If a mistake is made, the Macro Set can be restored to the last saved state. This will erase any changes made since the last save. This affects macro properties only, and not the associated scripts.


Stopping a Macro

An executing macro can be halted if the macro is a Phantom Script. This is accomplished by selecting the 'Stop' menu item from the 'Macro' menu in the main Sidekick window. Right-clicking on the [image] icon in the system tray, and selecting the 'Stop Executing Macro' pop-up will also stop the macro.

The macro will stop prior to executing the next Phantom instruction. All macros currently queued to run will not be run.


Hiding Sidekick

Under normal conditions, Phantom Sidekick will operate in the background, hidden from view. When Sidekick is hidden, all scheduled macros will be executed at the specified time. Also, all Triggers will be detected and will execute the appropriate macro. All this occurs with the Main Sidekick Window completely hidden.

When Sidekick is hidden, one of the following icons will appear in the System tray:

Waiting

Running

Scheduler disabled

Triggers disabled

Triggers and Scheduler disabled

Sidekick is recording actions

Double-clicking on the icon with the left mouse button on any of the above icons will cause the main Sidekick window to reappear. Sidekick can be hidden by either double-clicking on the icon in the System Tray, by selecting 'Hide' from 'File' menu, or by clicking the [image] button in the main tool bar.

Right-clicking on the icon in the System tray will cause the Macro Quick Menu to appear.


Macro Schedule

The Macro Schedule determines when a macro executes. Macros can be scheduled to run at a specific time or on a repeating basis. A macro that runs only once is a Single Occurrence. A macro that runs at specified time intervals is a Repeated macro. When the time arrives to execute either kind of scheduled macro, Sidekick will execute the macro automatically.

If the scheduled run time for a macro passes while Sidekick is not open, the macro will not run when Sidekick is opened. Therefore, all macros that are scheduled when Sidekick is not open will be skipped.

Single Occurrence Macros

Single Occurrence Macros have a specific date and time when they run. When the date and time arrives, the macro executes and is not executed again. Single occurrence macros are indicated by the [image] icon.

Repeated Macros

Repeated Macros are run at a specified interval. The interval can be in seconds, minutes, hours, days, weeks, months or years. When the interval passes, the macro is executed. A Repeated Macro also has a staring time that all intervals are measured against. This starting time can be in the past, present, or future. For example:

A macro is scheduled to run every three days at 2:00 AM. The starting date is two days prior to the current date. Therefore, the macro will run the next day. This is because the difference between the start date and current date will be three days at that time. It will also run every three days at 2:00 AM after that.

A Repeated Macro is indicated by the [image] icon.

Macros can be scheduled by either using the Macro Manager or the Macro Scheduler.


Sidekick Menu

Sidekick Menus

The following illustrates the menu layout of Phantom Sidekick.

File

·Hide - Hides Sidekick

·Macro Wizard - Opens the Macro Wizard

·Save Macros - Saves the macro set

·Restore Macros - Restores the Macro Set

·Exit - Exits Sidekick

Macro

·New Macro - Clears the Macro Manager to create a new macro

·Cut - Cuts a macro or set in the Macro Viewer

·Copy - Copies a macro or set in the Macro Viewer

·Delete - Deletes a macro or set in the Macro Viewer

·Paste

·Paste In - Pastes a macro or set in the currently selected set

·Paste After - Pastes a macro or set after the currently selected macro or set

·Paste Before - Pastes a macro or set before the currently selected macro or set

·Edit - Edits the Macro File of the currently selected macro

·Execute - Executes the currently selected macro

·Stop - Stopsthe currently executing macro

Script

·New - Opens the Script Editor to create a new Phantom script

·Open - Opens the currently selected macro's Macro File in the Script Editor

·Record

·Script - Records a new script

·Window Declarations - Opens the Window Declarations Recorder. See the Phantom help file for more information

Log

·Save Log File -Saves the Sidekick Log file

·Clear Log Display - Clears the text in the Sidekick Log display

·Clear Log File - Deletes the contents of the Sidekick Log file

Settings

·Disable Scheduler - Prevents all Scheduled Macros from executing when selected

·Disable Scheduler - Prevents all Triggers from executing a macro when selected

·Options - Opens the Settings dialog

Help

·About - Displays version information about Sidekick

·Sidekick - Displays this help file

·Phantom - Displays the Phantom help file


Sidekick Log

The Sidekick Log window displays the macros executed since the start of the application along with the respective execution times. The first column is the date and time of execution and the second column is the name of the macro. Any Sidekick related execution errors are also displayed in the log.

The Sidekick log is used to determine if and when macros have executed. It is not used to determine error information or output from a script. This information is displayed in the Macro Output screen.

Log information is also saved to a file called ‘Sidekick.log’ located in the installation directory of sidekick. This file contains a list of all macros executed. It has the same format as the Sidekick Log window.

The Log window automatically clears every 200 macro executions, or can be cleared manually using the ‘Clear Display’ button. The Log file can be cleared using the ‘Clear Log File’ button or by deleting the file manually. If the Log file is not cleared periodically, it can become quite large. For this reason, the Log file can be cleared automatically when the size reaches a certain number of lines. This number can be changed by using in the Settings. It is recommended that the Log file be cleared ever 1000 lines or less to prevent Sidekick performance loss. Setting the number to 0 causes the log file to never clear, and does not hinder Sidekick performance. The Log file can be backed up to another file using the ‘Save Log File As’ button.


Macro Output

The Macro Output window is used to display the output of a Phantom script. Non-Phantom macros do not use this window. The Output window will display any errors from a Phantom script, along with any manual displays from the script (such as PrintMessage). This does not display the contents of the Phantom script Log file.

The Output screen only shows the output of the last macro executed.


What are Macros?

Macros are a set of commands that run automatically to make using a computer or computer application easier. Phantom Sidekick macros are designed to make using the Windows Operating System and associated applications easier to use.

This is accomplished by sending commands to the computer as if they were sent by you. The computer takes these commands and performs actions, such as logging on to e-mail, copying a set of files, formatting a document, or surfing the web. The difference is, you only click the mouse once or type a few keys, and Phantom does the rest. Phantom also does it much quicker than you can.

A macro is created by creating a Phantom Script or by Recording a Script. Sidekick then waits for a command to execute or a trigger (a key combination), and then plays back the recorded actions or or script commands.

With Phantom Sidekick and the Phantom language, any windows task can be automated. Copy files while away, check e-mail periodically, download updated files, or perform any repetitive task automatically - the possibilities are endless!!!


Macro Viewer

The Macro Viewer

The Macro Viewer is used to view and organize all the Phantom Sidekick macros. Macros can be copied, edited, executed, deleted and organized using the Macro Viewer. All new macros available for use in Sidekick are displayed in the Macro Viewer. The Macro Viewer also displays general scheduling characteristics of macros at a glance.

The Macro Viewer uses the same display format as the Macro Quick Menu, but each serves a different purpose.

The Root Macro Set

The Root is the top macro set under which all macros are located. By default, this set is called ‘My Macros’, although the name can be changed by using the Macro Manager. The root macro can not be deleted or have any attributes modified other than the name.

Organizing Macros

Macros can be organized into groups, or Sets, using the macro viewer and macro manager. Each set contains one or more macros and sub-sets. Once a set contains sub-items (either macros or sub-sets), the set status can not be changed until all the sub-items are removed.

Macros are placed in a set by selecting the set and adding a new macro from the Macro Manager or by using the Macro Wizard. The name of the macro will be displayed in the new set. Sub-sets are added by creating a new set using the Macro Manager.

Cutting, Copying, and Pasting

Macros and macro sets can be rearranged by copying, cutting and pasting macros. Copying is accomplished by selecting a macro or set and selecting the ‘Copy’ menu item from the ‘Macro’ menu. Similarly, cutting can be performed by selecting a macro or set and selecting the ‘Cut’ menu item from the ‘Macro’ menu. After a cut or copy operation has been performed, the item can be pasted into another set, after a set or macro, or before a set or macro. These actions can be performed by selecting the ‘Paste In’, ‘Paste After’, or ‘Paste Before’ menu in the Macro->Paste menu. These operations can also be performed by right-clicking a macro or set and selecting the appropriate menu item from the pop-up menu.

Moving a macro can be accomplished by simply dragging the macro from its current location to the new location by using the mouse.

Deleting a Macro

A macro can be deleted from a macro set by selecting a macro or set and selecting the ‘Delete’ menu item from the ‘Macro’ menu. Right-clicking the macro and selecting the ‘Delete’ menu item from the pop-up menu will perform the same task. Deleting a macro simply removes the macro from the macro list. All properties, including the name, schedule, and Trigger will be erased permanently. The associated Phantom script file, if any, will not be deleted.

Executing a Macro from the Macro Viewer

A macro can be executed directly from the Macro Viewer. This is done by selecting the macro, right-clicking, and selecting the ‘Execute’ menu item from the pop-up menu. Selecting the ‘Execute’ menu item from the ‘Macro’ menu or the [image] button from the main tool bar will perform this same task. A macro executed in this fashion will wait for any other macros in the execution queue to complete before executing.

Editing a Macro from the Macro Viewer

A macro’s Macro File can be opened in the Sidekick Editor directly from the Macro Viewer. Simply right-click on the macro and select the ‘Edit’ menu item from the pop-up menu. The Macro File will be opened in the Macro Editor. Any file can be opened using the editor, although the editor is specifically designed for Phantom scripts. A file can also be edited by selecting the macro and choosing the ‘Edit’ menu item from the ‘Macro’ menu or by clicking the [image] button in the main tool bar.